#!/usr/bin/env python3
from math import *


def is_prime(i):
    if i < 0: return False
    if i not in primes.keys(): primes[i] = not any(i % x == 0 for x in range(2, int(floor(sqrt(i))) + 1))
    return primes[i]


def is_valid(p, guess, res):
    gud = [c for c, r in zip(guess, res) if r != "w"]
    for i, (c, r) in enumerate(zip(guess, res)):
        if r == "w" and (c == p[i] if c in gud else c in p): return False
        if r == "y" and (c == p[i] or c not in p): return False
        if r == "g" and c != p[i]: return False
    return True


def perform_guess(guess_int):
    global left
    _, res = print(guess := str(guess_int)), input().strip()
    if res == "ggggg": return True
    left = [p for p in left if p != guess and is_valid(p, guess, res)]
    # print(left, file=sys.stderr)


n, primes = int(input()), {0: False, 1: False, 2: True, 3: True}
primes_list = [str(i) for i in range(100_000) if is_prime(i) and i > 10_000]
start_a, start_b = next((a, b) for a in primes_list for b in primes_list if sorted(f"{a}{b}") == list("0123456789"))

for _ in range(n):
    left = list(primes_list)
    if perform_guess(start_a) or perform_guess(start_b): continue
    while not perform_guess(left[0]): pass
