#!/usr/bin/env python3
import sys
import random

LEN = 5


def is_prime(p):
    i = 2
    while i * i <= p:
        if p % i == 0:
            return False
        i += 1
    return True


def test(g, p, pattern):
    guess = [0] * LEN
    prime = [0] * LEN
    for i in range(LEN):
        guess[LEN - 1 - i] = g % 10
        g //= 10
        prime[LEN - 1 - i] = p % 10
        p //= 10
    # check greens
    remove = []
    for i in range(LEN):
        if (pattern[i] == "g") != (guess[i] == prime[i]):
            return False
        if guess[i] == prime[i]:
            remove.append(prime[i])
    # Remove green chars
    for x in remove:
        prime.remove(x)

    # Check yellow
    for i in range(LEN):
        if pattern[i] == "y":
            if prime.count(guess[i]) == 0:
                return False
            prime.remove(guess[i])

    # Check white
    for i in range(LEN):
        if pattern[i] == "w":
            if prime.count(guess[i]) > 0:
                return False

    return True


n = int(input())
all_primes = [p for p in range(10 ** (LEN - 1), 10**LEN) if is_prime(p)]
for _ in range(n):
    primes = all_primes[:]

    # Repeatedly pick a random prime, and filter all options.
    while True:
        guess = primes[random.randint(0, len(primes) - 1)]
        print(guess, flush=True)
        pattern = input()
        if pattern == "g" * LEN:
            break
        primes = [p for p in primes if test(guess, p, pattern)]
        # print(f"Left: {len(primes)}", file=sys.stderr)
