#!/usr/bin/env python3

S = set()

n = int(input())

for i in range(n):
    m = int(input())
    cc = [list(map(int, input().split())) for i in range(m)]
    x = [c[0] for c in cc]
    y = [c[1] for c in cc]
    
    # compute some arbitrary fingerprint that is invariant under translation
    # e.g. m, x-variance, y-variance, covariance
    # scaled to integer for use in set()
    xexp = sum(x)
    yexp = sum(y)
    xvar = m*sum([xx*xx for xx in x])-xexp**2
    yvar = m*sum([yy*yy for yy in y])-yexp**2
    cov = m*sum([x[i]*y[i] for i in range(m)]) - xexp*yexp
    S.add((m, xvar, yvar, cov))

print(len(S))